//(16x16Dot)LED Game for AVR  by Takuya Matsubara / NICO Corp. 2008
// http://www.nicotak.com/avr/
//
//  UNE UNE
//

//---------------------------------------------------------------------
#include <avr/io.h>
#include <avr/interrupt.h>
#include "led.h"
#include "sw.h"
#include "rand.h"
#include "beep.h"
#include "vect.h"

typedef struct {
	int ang;    /* px */
	char len;    /*  */
} VECLINE;



//---------------------------------------------------------------------
// 

void keywait(void)
{
	while(sw_get(SW_A));	// XCb`
}


int anglefix(int angle){
	if(angle < 0  ) angle += 360;
	if(angle > 360) angle -= 360;

	return(angle);
}


int main(void)
{
#define CHANGECNT 200
#define KANSETUMAX 8
	int i;
	int cnt;
	int x=8,y=15;
	int tempkak;
	int ang=0;
	int angd;
	int ifix=KANSETUMAX-1;
	int x1,y1,x2,y2,ang2;
	VECLINE une[KANSETUMAX];
	VECLINE *pV;

	beep_init();
	led_init();			// LED
	rand_init();
	sw_init(SW_ALL);	// XCb`

	for(i=0; i<KANSETUMAX; i++){
		une[i].ang = 0;
		une[i].len = 3;
	}

	sei();
	while(1)
	{
		led_disp();
		cnt++;
		if(cnt < CHANGECNT) continue;
		cnt=0;

		led_init();	//ʃNA

		pV = &une[0];
		x2 = x;
		y2 = y;
		ang2 = ang;
		for( i=0; i<KANSETUMAX; i++){

			tempkak = pV->ang + ang2;
			x1 = vect_x1(tempkak)* pV->len;
			y1 = vect_y1(tempkak)* pV->len;
			x1 = x1/256 + x2;
			y1 = y1/256 + y2;
			led_line(x1,y1,x2,y2,1);
			x2 = x1;
			y2 = y1;
			ang2 = tempkak;
			pV++;
		}

		if (sw_get(SW_UP)) {	// {^
			y--;
			if(y<0)y=0;
		}
		if (sw_get(SW_DOWN)) {	// {^
			y++;
			if(y>15)y=15;
		}
		if(sw_get(SW_LEFT)){     // {^
			x--;
			if(x<0)x=0;
		}
		if(sw_get(SW_RIGHT)) {     //{^
			x++;
			if(x>15)x=15;
		}
		if(sw_get(SW_A)) {     //A{^
			ang += 10;
			ang = anglefix( ang );

			beep_set(rand_get(250)+660,1);

		}else if(sw_get(SW_B)) {     //B{^
			for(i=0; i<KANSETUMAX; i++){
				if(une[i].ang > 180)
					une[i].ang+=10;
				else
					une[i].ang-=10;
			}
			beep_set(rand_get(250)+360,1);
		}else{
			for(i=0; i<KANSETUMAX; i++){
				angd = rand_get(11)-5;
				une[i].ang += angd;
				une[i].ang = anglefix( une[i].ang );
			}
//			if((angd <= -5)||(angd >= 5))
//				beep_set(rand_get(100)+160,1);
		}
	}
	return 0;
}


